/*
	specific implemetation for accessing data in the file
*/

import java.io.*;
import java.util.*;
import java.lang.*;

import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public class fileModule implements dataAccess {

    private File FileLocation;
    private InputStream inStream;
    private TXDocument doc;
    private Element root;
    private String tmp_filename = null;
    
    public void open(String protocol, String location, String id, String pwd) {
        
        FileLocation = new File(location);
        tmp_filename = location;
                
        if (!FileLocation.exists()) {
            
			try {

				throw new java.io.FileNotFoundException(location);

			} catch (FileNotFoundException e) {

				e.printStackTrace();
			}
			
        } else {
            
            try {
                
                inStream = new FileInputStream(location);
                
            } catch (Exception e) {
                
                e.printStackTrace();
                return;
            }
            
            // make the DOM tree, of which root is doc
            
            doc = new Parser(location).readStream(inStream);
            root = (Element)doc.getDocumentElement();
            
            try {
                
                // close the input stream
            
                inStream.close();
                
            } catch (IOException e) {
                
                e.printStackTrace();
            }
        }
    }
    
    public void close() {
        
    }
    
    public void update() {
        
        String charset = "ISO-8859-1";      // MIME charset name
        String jencode = MIME2Java.convert(charset);
        PrintWriter pw;
        
        try {
            
            pw = new PrintWriter(new BufferedWriter(new FileWriter(tmp_filename)));
            
        } catch (IOException e) {
            
            e.printStackTrace();
            return;
        }
        
        doc.setEncoding(charset);
        
        try {
            
            // print DOM tree in XML format using the specified encoding
            
            doc.printWithFormat(pw, jencode);
            
        } catch (IOException e) {
            
            e.printStackTrace();
        }
                
        // close the output stream
        
        pw.close();
    }

    public String getValue(String name, String key) {
          
        if (root.hasChildNodes()) {

            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
           
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    NodeList keys = users.item(i).getParentNode().getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        String key_name = keys.item(j).getNodeName().toLowerCase();
                        
                        if (key_name.equals(key.toLowerCase()) && keys.item(j).getNodeType() == Node.ELEMENT_NODE) {
                            
                            return keys.item(j).getChildNodes().item(0).getNodeValue();
                        }
                    }
                }
            }
        }
                     
        return null;
    }

    public Enumeration getUsers() {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {
            
            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    result.addElement(users.item(i).getChildNodes().item(0).getNodeValue());
                }
            }
        }

        return result.elements();
    }
    
    public void addUser(String name) {

        // make the new user in order to insert
        
        TXElement new_user = (TXElement) doc.createElement("user");
        TXElement new_user_name = (TXElement) doc.createElement("name");
        new_user_name.appendChild(doc.createTextNode(name));
        new_user.appendChild(new_user_name);
        
        if (root.hasChildNodes()) {
            
            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
                
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {

                    // replace the old user by the new user if the given user exists
                    
                    try {
                            
                        //root.replaceChild(users.item(i).getParentNode(), new_user);
                        //return;
                        root.removeChild(users.item(i).getParentNode());
                            
                    } catch (DOMException e) {
                            
                        e.printStackTrace();
                    }
                }
            }
        }
        
        // add the new user if the given user does not exist
        
        root.appendChild(new_user);
    }
    
    public void removeUser(String name) {

        if (root.hasChildNodes()) {
            
            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
                
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    try {
                            
                        root.removeChild(users.item(i).getParentNode());
                        return;
                            
                    } catch (DOMException e) {
                            
                        e.printStackTrace();
                    }
                }
            }
        }
    }    
    
    public Enumeration getUserKeys(String name) {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {

            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
           
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    NodeList keys = users.item(i).getParentNode().getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        if (keys.item(j).getNodeType() == Node.ELEMENT_NODE) {
                            
                            result.addElement(keys.item(j).getNodeName().toLowerCase());
                        }
                    }
                    
                    return result.elements();
                }
            }
        }
        
        return null;
    }
    
    public void setValue(String name, String key, String value) {

        if (root.hasChildNodes()) {

            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
           
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    NodeList keys = users.item(i).getParentNode().getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        String key_name = keys.item(j).getNodeName().toLowerCase();
                        
                        if (key_name.equals(key.toLowerCase())) {
                            
                            // modify the value if the user has the given key
                            
                            keys.item(j).getChildNodes().item(0).setNodeValue(value);
                            return;
                        }
                    }
                    
                    // create the new key unless the user has the given key
                            
                    TXElement new_key = (TXElement) doc.createElement(key);
                    new_key.appendChild(doc.createTextNode(value));
                    users.item(i).getParentNode().appendChild(new_key);
                    return;
                }
            }
        }
    }
    
    public void removeKey(String name, String key) {

        if (root.hasChildNodes()) {

            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
           
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    NodeList keys = users.item(i).getParentNode().getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        if (keys.item(j).getNodeName().toLowerCase().equals(key.toLowerCase())) {
                            
                            users.item(i).removeChild(keys.item(j));
                        }
                    }
                    
                    return;
                }
            }
        }
    }    
   
}


